// Compiler : Borland C++ Builder 4 Pro
// Author : Gorkem Ismail Ates BM-2 97131021
// Submitted to : PH.D. Kivanc Dincer
// Submission Date : 31th May 1999 (Demo)
// Development Period : 20th May 1999 - 30th May 1999 with long(!) break times
// Subject : B+ Tree Implementation for Birth Year Date Lookup using query key: name
// License : All rights reserved. Can not be used without prior written permission from author

#pragma hdrstop
#include <vcl.h>
#include <iostream.h>
#include <conio.h>
#include <condefs.h>
#include "BPlusTreeProject.hpp"

//---------------------------------------------------------------------------
#pragma argsused

BTree::BTree() // CHECKED
// constructor of BTree class--this is actually B+ Tree Class
{
        Root = 0;
        Level = 0;
}
//---------------------------------------------------------------------------

Node* BTree::SeekNode(int levelupfromleaf, String Query) // CHECKED
                // also used in B Tree Imp. as well as B+ Tree
{               // this method serches Query from Root to the level specified
                // 0 -> leaf

                if(Level < levelupfromleaf)
                {
                        // if no level is present return 0
                        return 0;
                }

                Node *tempnode = Root; // take root as the starting node;
                int levelcounter = 0;  // the level of root

                // unless we reach the leaf or the level specified
                while(tempnode && (tempnode->Leaf == false) && (Level - (levelcounter + levelupfromleaf)))
                {
                        int a = 2*V;

                        for(int i = (2 * V - 1); i >= 0; i--)
                        {
                                if(Query <= tempnode->GetValue(i) || tempnode->GetValue(i) == "")
                                        a = i;
                        }

                        // when found the node jump to there
                        tempnode = tempnode->GetPtr(a);
                        levelcounter++;
                }
                return tempnode;
}
//---------------------------------------------------------------------------

void BTree::InsertData(Node* tempnode, String input, int input2, Node* RightNode, Node* LeftNode) // CHECKED
{       // inserts data one node with empty space. Also manages the subnodes of the inserted node
        if(tempnode->Spaces_Left) // if there exist empty space
                tempnode->Spaces_Left--; // use it up.

        String string;
        int data = 0;

        for(int i = 0; i < 2*V; i++) // scan through records of the node
        {      // if value of the node is greater than or equal to input or if
               // we reach the end of the nodes full records--that is we face an empty record
               if(input <= tempnode->GetValue(i))
               {
                       for(int a = 2*V-2; a>=i; a--)
                       { // shift all records to empty space -- both stringwise and pointerwise
                               tempnode->GetValueEx(a, string, data);
                               tempnode->SetValueEx(a+1, string, data);
                       }
                       for(int a = 2*V-1; a>=i; a--)
                               tempnode->SetPtr(a+1, tempnode->GetPtr(a));

                       // copy the input to the freed space in the node
                       tempnode->SetValueEx(i, input, input2);
                       tempnode->SetPtr(i, LeftNode); // and don't forget to set the pointer
                       tempnode->SetPtr(i+1, RightNode);
                       break;
               }
               if(tempnode->GetValue(i)=="")
               {
                       // copy the input to the first free space in the node
                       tempnode->SetValueEx(i, input, input2);

                       tempnode->SetPtr(i+1, RightNode); // and don't forget to set the pointer
                       tempnode->SetPtr(i, LeftNode);
                       break;
               }
        }
}
//---------------------------------------------------------------------------

Node* BTree::SplitNode(Node *tempnode, String input, int input2, String &output, Node *KeyPtr, Node *RightKeyNode) // NOT CHECKED
{       // splits one full record into two new records and returns the newly created node by value
        // and returns the string value to be raised into tree by reference

        // tempnode->Root = false;

        Node *newnode = new Node(tempnode->GetParent());
        // a new record is created at the right of the new one whose parent is same as his brother

        String string; // temporary storage for copying string values
        int data;      // temporary storage for copying integer values

        int counter = 2*V-1;
        bool FirstTime = true;
        bool NewCopied = false;
        // join the new item with the ones in old node and raise the middle item to index

        for(int i = 0; i < V; i++)
        {
                if(tempnode->GetValue(counter) < input && FirstTime)
                {
                                FirstTime = false;
                                NewCopied = true;
                                newnode->SetValueEx(i, input, input2);
                                newnode->SetPtr(i, KeyPtr); // what value do we really want to pass???
                                newnode->SetPtr(i+1, RightKeyNode);
                                newnode->Spaces_Left--;
                }
                else
                {
                        tempnode->GetValueEx(counter, string, data);
                        tempnode->SetValueEx(counter, "", 0);
                        newnode->SetValueEx(i, string, data);
                        newnode->SetPtr(i, tempnode->GetPtr(counter));
                        tempnode->SetPtr(counter, 0);
                        counter--;
                        newnode->Spaces_Left--;
                        tempnode->Spaces_Left++;
                }
        }

        if(!NewCopied) // in case we still couln't included the new key
                       // so it belongs to left node
                InsertData(tempnode, input, input2, RightKeyNode, KeyPtr);  // ?????


        output = tempnode->GetValue(V);

        return newnode;
}
//---------------------------------------------------------------------------
                        // level is the relative spanner that traces the layers from 0 to Level
void BTree::InsertBTree(int level, String ToLeverage, Node *RightNode, Node *LeftNode) // almost CHECKED (Level????)
{       // inserts the value and the pointer to the index tree
        // parameter level is the distance from leaf (leaf itself is 0)
        Node *IndexNode = SeekNode(level, ToLeverage); // find the correct node wrt variable Level

        if(!IndexNode) // if no node is present in that level
        {       // create the node and insert values to it
                Node *NewRoot = new Node(0);
                Root->SetParent(NewRoot); // old root is dead. long live new one
                Root = NewRoot;
                Level++; // we have gained one more level
                cout << "Level is increased to " << Level;
                InsertData(Root, ToLeverage, 0, RightNode, LeftNode);
        }
        else if(IndexNode->Spaces_Left) // if empty space is available in the index node
        {
                InsertData(IndexNode, ToLeverage, 0, RightNode, LeftNode);
        }       //0 is the value of the integer that is birthyear--obsolete for index nodes
        else
        {
                // no need to run specific routine for root --it is simply a node with level&ptr 0

                // split the full node
                Node *NewRightIndexNode = SplitNode(IndexNode, ToLeverage, 0, ToLeverage, LeftNode, RightNode);
                // pass the newly created node as a parameter to a level higher version of this method
                InsertBTree(++level, ToLeverage, NewRightIndexNode, IndexNode);
        }
}
//---------------------------------------------------------------------------

void BTree::AddValue(String input, int input2) // almost CHECKED
{
        if(Root == 0) // if this is the first node and --thus-- first record
        {
                Root = new Node(0); // allocate a node for Root node
                Root->Leaf = true;
                InsertData(Root, input, input2, 0, 0); // insert the "siftah" into the first root node
        }
        else // if other nodes exist
        {
                Node *SuitableNode = SeekNode(0, input);  // find the leaf correspondent
                // 0 indicates we're searching for a leaf one

                Node *temp = Root;
                Node *temp2 = Root->GetPtr(0);
                Node *temp3 = Root->GetPtr(1);
                Node *temp4 = Root->GetPtr(2);
                if(temp2)
                {
                        Node *temp5 = Root->GetPtr(0)->GetPtr(0);
                        Node *temp6 = Root->GetPtr(0)->GetPtr(1);
                        Node *temp7 = Root->GetPtr(0)->GetPtr(2);
                }
                if(temp3)
                {
                        Node *temp8 = Root->GetPtr(1)->GetPtr(0);
                        Node *temp9 = Root->GetPtr(1)->GetPtr(1);
                        Node *temp10 = Root->GetPtr(1)->GetPtr(2);
                }
                if(temp4)
                {
                        Node *temp11 = Root->GetPtr(2)->GetPtr(0);
                        Node *temp12 = Root->GetPtr(2)->GetPtr(1);
                        Node *temp13 = Root->GetPtr(2)->GetPtr(2);
                }


                if(SuitableNode->Spaces_Left) // if empty place is present in appropriate leaf node
                {
                        InsertData(SuitableNode, input, input2, 0, 0); // simply insert the data into the leaf node
                }
                else // if the leaf node is full and has to be splitted
                {
                        String ToLeverage; // the value to raise to the index tree
                        Node *NewNodeAfterSplit = SplitNode(SuitableNode, input, input2, ToLeverage, 0,0);
                        NewNodeAfterSplit->Leaf = true;
                        // the right node after splitting operation
                        //-----------------end of b+tree---------------------------
                        //-----------------beginning of b tree---------------------
                        InsertBTree(1, ToLeverage, NewNodeAfterSplit, SuitableNode); // why 1 as the 1st parameter??
                        // Because we want to insert to the first index tree layer
                        //-----------------end of b tree (recursive inside)--------
                }
        }
}
//---------------------------------------------------------------------------

int BTree::GetValue(String query)
{
                Node *tempnode = Root;
                String input = query;

                while(tempnode && tempnode->Leaf == false) // find the leaf correspondent
                {
                        int a = 2*V-1;
                        for(int i = 2*V - 1; i >=0; i--)
                        {
                                if(input < tempnode->GetValue(i) || tempnode->GetValue(i)=="")
                                        a = i;
                        }
                        tempnode = tempnode->GetPtr(a);
                }

                for(int i=0; i< 2*V; i++)
                        if(tempnode->GetValue(i)==query)
                        {
                                int a;
                                String b;
                                tempnode->GetValueEx(i, b, a);
                                return a;
                        }

                return 0;
}
//---------------------------------------------------------------------------

void BTree::DeleteValue(String input)
{
                Node *tempnode = Root;
                bool Last = true;
                // String input = query;

                while(tempnode->Leaf == false) // find the leaf correspondent
                {
                        int i;
                        for(i = 0; i < 2*V; i++)
                        {
                                if(input <= tempnode->GetValue(i))
                                {
                                        Last = false;
                                        break;
                                }
                        }
                        tempnode = tempnode->GetPtr(i);
                }

                for(int i=0; i< 2*V; i++)
                        if(tempnode->GetValue(i)==input)
                        {
                                delete tempnode;
                                break;
                        }
}
//---------------------------------------------------------------------------

Node::Node(Node *parent)
{
        Parent = parent;

        Leaf = false;

        for(register int i = 0; i <= 2*V; i++)
                Ptr[i] = 0;

        for(register int i = 0; i < 2*V; i++)
                Value[i] = "";

        Spaces_Left = 2*V;
}
//---------------------------------------------------------------------------

void Node::SetPtr(int index, Node *ptr)
{
        if(index < 2*V+1 && index >=0)
                Ptr[index] = ptr;
        else
                cerr << "Node class error 1: index of Ptr out of boundary";
}
//---------------------------------------------------------------------------

void Node::SetValue(int index, String input)
{
        if(index < 2*V && index >=0)
                Value[index] = input;
        else
                cerr << "Node class error 2: index of value out of boundary";
}
//---------------------------------------------------------------------------

void Node::SetValueEx(int index, String input, int input2)
{
        if(index < 2*V && index >=0)
        {
                Value[index] = input;
                Data[index] = input2;
        }
        else
                cerr << "Node class error 2: index of value out of boundary";
}
//---------------------------------------------------------------------------

Node* Node::GetParent(void)
{
        return Parent;
}
//---------------------------------------------------------------------------

Node* Node::GetPtr(int index)
{
        if(index>=0 && index<=2*V)
                return Ptr[index];

        cerr << "Node class error 3: index of Ptr is out of boundary";
        return 0;
}
//---------------------------------------------------------------------------

String Node::GetValue(int index)
{
        if(index >= 0 && index < 2*V)
                return Value[index];

        cerr << "Node class error 4: index of Value is out of boundary";
        return 0;
}
//---------------------------------------------------------------------------

void Node::GetValueEx(int index, String &output, int &output2)
{
        if(index >= 0 && index < 2*V)
        {
                 output = Value[index];
                 output2 = Data[index];
        }
        else
                cerr << "Node class error 4: index of Value is out of boundary";
}
//---------------------------------------------------------------------------

void Node::SetParent(Node *p)
{
        Parent = p;
}
//---------------------------------------------------------------------------

int main(int argc, char* argv[])
{
        cout << "\nWelcome to Gorkem's BTI (B+ Tree Implementation): \"A new dimension in database systems\"";

        BTree GorkemsBPlusTree;

        GorkemsBPlusTree.AddValue("Gorkem", 1979);
        GorkemsBPlusTree.AddValue("Gozen", 1972);
        GorkemsBPlusTree.AddValue("Millenium", 2000);
        GorkemsBPlusTree.AddValue("Ahmet", 1975);
        GorkemsBPlusTree.AddValue("Metallica", 1980);

        GorkemsBPlusTree.AddValue("Microsoft", 1974);
        GorkemsBPlusTree.AddValue("Fastream", 1998);
        GorkemsBPlusTree.AddValue("TBMM", 1920);

        GorkemsBPlusTree.AddValue("IBM", 1911);
        GorkemsBPlusTree.AddValue("Istanbul", 1453);

        cout << "Added records for Gorkem, Gozen, Millenium, Ahmet, Metallica, Microsoft, Fastream, TBMM, IBM, and Istanbul.";

        char *inputch = new char[256];
        String input;

        while(input!="quit")
        {
                cout << "\nEnter any keyword to query database:(quit quits)\n";
                cin >> inputch;
                input = (String)inputch;
                if(input != "quit")
                {
                        cout << GorkemsBPlusTree.GetValue(input);
                }
        }

        cout << "Thank you for using Gorkems BTI: \n\"A new dimension in database systems\"\n";

        cout << GorkemsBPlusTree.GetValue("Gozen");
        cout << GorkemsBPlusTree.GetValue("Gorkem");
        cout << GorkemsBPlusTree.GetValue("Ahmet");
        cout << GorkemsBPlusTree.GetValue("Millenium");
        cout << GorkemsBPlusTree.GetValue("TBMM");
        cout << GorkemsBPlusTree.GetValue("IBM");
        cout << GorkemsBPlusTree.GetValue("Istanbul");
        cout << GorkemsBPlusTree.GetValue("Metallica");

        return 0;
}

