// header file for B+ Tree Implementation
#include <vcl.h>
#define V 1

class Node
{
        private:
                Node *Ptr[2*V+1];
                String Value[2*V];
                int Data[2*V];
                Node *Parent;
        public:
                bool Leaf;
                int Spaces_Left;

                Node(Node *parent);
                void SetPtr(int index, Node *ptr);
                void SetValue(int index, String input);
                void SetValueEx(int index, String input, int input2);
                void SetParent(Node *p);

                Node *GetParent(void);
                Node *GetPtr(int index);
                String GetValue(int index);
                void GetValueEx(int index, String &output, int &output2);
};

class BTree  // this is actually b+ tree not b tree
{
        private:
                int Level;
                Node *Root;
                Node *SeekNode(int levelupfromleaf, String Query);
                void InsertData(Node* tempdata, String input, int input2, Node* newnode, Node* oldnode);
                Node* SplitNode(Node *tempnode, String input, int input2, String &output, Node *KeyPtr, Node *RightKeyNode);
                void InsertBTree(int Level, String ToLeverage, Node *oldnode, Node *newnode);  // this IS the btree insertion algorithm
        public:
                BTree();
                void AddValue(String input, int input2);
                int GetValue(String query);
                void DeleteValue(String input);
};
