//#include <iostream.h>
#include <stdio.h>
#include <conio.h>
#include <iomanip.h>
#include <ctype.h>
#define V	2
#define M 2*V+1

typedef int dtype;  // For flexiblity, to change the data type...

enum status {
			InsertNotComplete,
			Success,
			DuplicateKey,
			Underflow,
			NotFound
		  };  // The messages by numbers

struct node
{
	int n;        // (n < M		)
	dtype k[M-1]; // (Max to store	)
	node *p[M];   // (n+1 in use	)
};

//        Ŀ
//   *p[0](k[0])*p[1](k[1])*p[2] ... *p[n-1](k[n-1])*p[n]
//	     
//
//          p[0], k[0], p[1], k[1], ..., p[n-1], k[n-1], p[n]

class Btree {
public:
   Btree(): root(NULL){}
   void insert(dtype x);
   void print()const{printf("Contents of B+ Tree: \n"); pr(root, 0);}
   void DelNode(dtype x);
   void ShowSearch(dtype x)const;
private:
   node *root;
   status ins(node *r, dtype x, dtype &y, node* &u);
   void pr(const node* r, int nSpace)const;
   int NodeSearch(dtype x, const dtype *a, int n)const;
   status del(node *r, dtype x);
};

void Btree::insert(dtype key)
{  node *pNew;
   dtype xNew;
   status code = ins(root, key, xNew, pNew);
   if (code == DuplicateKey)
	 printf("This key already exists.\n     Not inserted\n");
   if (code == InsertNotComplete)
   {  node *root0 = root;
	 root = new node;
	 root->n = 1; root->k[0] = xNew;
	 root->p[0] = root0; root->p[1] = pNew;
   }
}

status Btree::ins(node *r, dtype x, dtype &y, node* &q)
{
   // The available results of messages :
   // Success, DuplicateKey or InsertNotComplete.
   // So, insertion is done as the result.
   node *pNew, *pFinal;
   int i, j, n;
   dtype xNew, kFinal;
   status code;
   if (r == NULL){q = NULL; y = x; return InsertNotComplete;}
   n = r->n;
   i = NodeSearch(x, r->k, n);
   if (i < n && x == r->k[i]) return DuplicateKey;
   code = ins(r->p[i], x, xNew, pNew);
   if (code != InsertNotComplete) return code;

   if (n < M - 1)
   {  i = NodeSearch(xNew, r->k, n);
	 for (j=n; j>i; j--)
	 {  r->k[j] = r->k[j-1]; r->p[j+1] = r->p[j];
	 }
	 r->k[i] = xNew; r->p[i+1] = pNew; ++r->n;
	 return Success;
   }

   if (i == M - 1) {kFinal = xNew; pFinal = pNew;} else
   {  kFinal = r->k[M-2]; pFinal = r->p[M-1];
	 for (j=M-2; j>i; j--)
	 {  r->k[j] = r->k[j-1]; r->p[j+1] = r->p[j];
	 }
	 r->k[i] = xNew; r->p[i+1] = pNew;
   }

   int h = (M - 1)/2;
   y = r->k[h];
   q = new node;
   // p[0],k[0],p[1],...,k[h-1],p[h]
   // k[h] 'tan ncesi
   r->n = h;
   // p[h+1],k[h+1],p[h+2],...,k[M-2],p[M-1],kFinal,pFinal
   // k[h] 'tan sonras
   q->n = M - 1 - h;
   for (j=0; j < q->n; j++)
   {  q->p[j] = r->p[j + h + 1];
	 q->k[j] = (j < q->n - 1 ? r->k[j + h + 1] : kFinal);
   }
   q->p[q->n] = pFinal;
   return InsertNotComplete;
}

void Btree::pr(const node *r, int nSpace)const
{  if (r)
   {  int i;
	 for (int spc=1; spc<=nSpace; spc++) printf(" ");
	 printf("{");
	 for (i=0; i < r->n; i++)
	 {
		if (i!=0) printf("  |");
		printf("%3d", r->k[i]);
	 }
	 printf("  }\n");
	 for (i=0; i <= r->n; i++) pr(r->p[i], nSpace+8);
   }
}

int Btree::NodeSearch(dtype x, const dtype *a, int n)const
{  int i=0;
   while (i < n && x > a[i]) i++;
   return i;
}

void Btree::ShowSearch(dtype key)const
{  printf("Path followed : \n");
   int i, j, n;
   node *r = root;
   while (r)
   {  n = r->n;
	 printf("->{");
	 for (j=0; j<r->n; j++)
	 {
		if (j!=0) printf("  |");
		printf(" %3d", r->k[j]);
	 }
	 printf("  }\n");
	 i = NodeSearch(key, r->k, n);
	 if (i < n && key == r->k[i])
	 {
		printf("Key %3d found in position %d of last displayed node.\n",
			    key, i+1);
		return;
	 }
	 r = r->p[i];
   }
   printf("Key %4d not found.\n", key);
}

void Btree::DelNode(dtype key)
{  node *root0;
   switch (del(root, key))
   {
   case NotFound:
	 printf("%4d not found.\n", key);
	 break;
   case Underflow:
	 root0 = root;
	 root = root->p[0];
	 delete root0;
	 break;
   }
}

status Btree::del(node *r, dtype x)
{  if (r == NULL) return NotFound;
   int i, j, pivot, n = r->n;
   dtype *k = r->k;  // To make k[i] reach to r->k[i]
   const int nMin = (M - 1)/2;
   status code;
   node **p = r->p, *pL, *pR;       // (Same as k[i] above)
							// p[i] reach to r->p[i]
   i = NodeSearch(x, k, n);
   if (p[0] == NULL) // refered to *r
   {
	if (i == n || x < k[i]) return NotFound;
	for (j=i+1; j < n; j++)
	{
		k[j-1] = k[j]; p[j] = p[j+1];
	}
	return
		(--r->n >= (r==root ? 1 : nMin) ? Success : Underflow);
   }
   if (i < n && x == k[i])
   {
	 node *q = p[i], *q1; int nq;
	 for (;;)
	 {  nq = q->n; q1 = q->p[nq];
	    if (q1 == NULL) break;
	    q = q1;
	 }
	 k[i] = q->k[nq-1];
	 q->k[nq - 1] = x;
   }
   code = del(p[i], x);
   if (code != Underflow) return code;
   // underflow while merge
   if (i > 0 && p[i-1]->n > nMin)
   {  pivot = i - 1; // k[pivot] , pL , pR
	 pL = p[pivot]; pR = p[i];
	 // *pR , *pL
	 pR->p[pR->n + 1] = pR->p[pR->n];
	 for (j=pR->n; j>0; j--)
	 {  pR->k[j] = pR->k[j-1];
	    pR->p[j] = pR->p[j-1];
	 }
	 pR->n++;
	 pR->k[0] = k[pivot];
	 pR->p[0] = pL->p[pL->n];
	 k[pivot] = pL->k[--pL->n];
	 return Success;
   }
   if (i<n && p[i+1]->n > nMin)
   {  pivot = i; // k[pivot] , pL , pR
	 pL = p[pivot]; pR = p[pivot+1];
	 // *pL , *pR
	 pL->k[pL->n] = k[pivot];
	 pL->p[pL->n + 1] = pR->p[0];
	 k[pivot] = pR->k[0];
	 pL->n++; pR->n--;
	 for (j=0; j < pR->n; j++)
	 {  pR->k[j] = pR->k[j+1];
	    pR->p[j] = pR->p[j+1];
	 }
	 pR->p[pR->n] = pR->p[pR->n + 1];
	 return Success;
   }
   // Merge
   pivot = (i == n ? i - 1 : i);
   pL = p[pivot]; pR = p[pivot+1];
   // k[pivot] , *pR , *pL
   pL->k[pL->n] = k[pivot];
   pL->p[pL->n + 1] = pR->p[0];
   for (j=0; j < pR->n; j++)
   {  pL->k[pL->n + 1 + j] = pR->k[j];
	 pL->p[pL->n + 2 + j] = pR->p[j+1];
   }
   pL->n += 1 + pR->n;
   delete pR;
   for (j=i+1; j < n; j++)
   {  k[j-1] = k[j]; p[j] = p[j+1];
   }
   return
   --r->n >= (r == root ? 1 : nMin) ? Success : Underflow;
}

void main()
{
//	  << M-1 << maximum number of elements in a node

   Btree t;
   dtype key;
   char ch;
   clrscr();
   printf("\nB-tree representation (indentation similar to the\n");
   printf("table of contents of a book). The items stored in\n");
   printf("each node are displayed on a single line.\n");

do{
   printf("Ŀ\n");
   printf(" I. Insert elements \n");
   printf(" D. Delete elements \n");
   printf(" S. Search  element \n");
   printf(" T. Show the B+Tree \n");
   printf(" X.      EXIT       \n");
   printf("\n");
   printf("\n Your Choice : ");
   do{ch = getch(); ch = toupper(ch);
	}while(ch!='I' && ch!='D' && ch!='S' && ch!='X' && ch!='T');
   putch(ch);

   switch(ch)
   {
	   case 'I':printf("\nEnter X to end the insertion process\n");
			  while(1)
			  {
				char digit;
				int number=0;

				do{
				   do{
					 do{
					    digit=getch();
					    if (isdigit(digit) || digit==13)
						   putch(digit);
					   }while((!isdigit(digit))&&
							(digit!=13)&&
							(toupper(digit)!='X'));
					   if (digit!=13 && toupper(digit)!='X')
						  number = 10*number + digit - '0';
					   if (digit==13) printf(" -> %d\n", number);
				    }while(digit!=13 && toupper(digit)!='X');
				    if (toupper(digit)!='X')
				    {
					   t.insert(number);
					   number = 0;
				    }
				  }while(toupper(digit)!='X');
				  break;
			  }
			  break;

	   case 'D':printf("\nEnter ^Z to end the deletion process\n");
			  while(1)
			  {
				char digit;
				int number=0;

				do{
				   do{
					 do{
					    digit=getch();
					    if (isdigit(digit) || digit==13)
						   putch(digit);
					   }while((!isdigit(digit))&&
							(digit!=13)&&
							(toupper(digit)!='X'));
					   if (digit!=13 && toupper(digit)!='X')
						  number = 10*number + digit - '0';
					   if (digit==13) printf(" -> %d\n", number);
				    }while(digit!=13 && toupper(digit)!='X');
				    if (toupper(digit)!='X')
				    {
					   t.DelNode(number);
					   number = 0;
				    }
				  }while(toupper(digit)!='X');
				  break;
			  }
			  break;

	   case 'S':printf("\nEnter element to search on tree\n");
			  scanf("%d", &key);
			  t.ShowSearch(key);
			  break;

	   case 'T':printf("\nCurrent Tree : \n");
			  t.print();
			  break;

   }
  }while(ch!='X');
}
